package skeleton;


import skeleton.DataFetcher;
import java.lang.reflect.*;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author szymon
 */


public class RequestInterface{

    /**
     *
     * @param dataFetcherName ia a name of a class that has to be created in order to
     * acquire data from the user. The class has to extend DataFetcher
     * @param attribute is a String that contains parameters that will be send to class of name dataFetcherName
     * @return response 
     */
    public final String request(final String dataFetcherName, final String parameters) throws Exception{
        Class c = Class.forName(dataFetcherName);
        Constructor ctor = c.getConstructor();
        final DataFetcher df = (DataFetcher)ctor.newInstance();
        df.setParameters(parameters);

        Object lock = null;
        lock = df.getLock();
        df.start();
        synchronized(lock) {
            while (df.running())
                try {
                    lock.wait();
                } catch (InterruptedException e) {e.printStackTrace();}

        }

        return df.getResponse().getData();
 
    }

}
