%
% therm_test.pl,v 1.5 2009-11-06 07:12:21 esimon Exp
%
% File generated by HeKatE Qt Editor ver. M6_5
%
% HeaRT case
%
%
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     HeaRT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of HeaRT.
%
%     HeaRT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     HeaRT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- ensure_loaded('../heart.pl').

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TYPES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xtype [name: boolean,
       base: numeric,
       length: 1,
       scale: 0,
       desc: boolean,
       domain: [0,1]
      ].
xtype [name: integer,
       base: numeric,
       length: 9,
       scale: 0,
       desc: integer,
       domain: [-999999999 to 999999999]
      ].


xtype [name: day,
       base: symbolic,
       domain: [mon/1,tue/2,wed/3,thu/4,fri/5,sat/6,sun/7],
       ordered: yes
      ].
xtype [name: hour,
       base: numeric,
       domain: [0 to 23]
      ].
xtype [name: month,
       base: numeric,
       domain: [1 to 12]
      ].
xtype [name: operation,
       base: symbolic,
       domain: [bizhrs,nbizhrs],
       ordered: yes
      ].
xtype [name: season,
       base: symbolic,
       domain: [spring,summer,fall,winter],
       ordered: yes
      ].
xtype [name: thermostat_settings,
       base: numeric,
       domain: [14,15,16,18,20,24,27]
      ].
xtype [name: today,
       base: symbolic,
       domain: [workday,weekend],
       ordered: yes
      ].

%%%%%%%%%%%%%%%%%%%%%%%%% ATTRIBUTES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xattr [name: day,
       abbrev: day,
       class: simple,
       type: day,
       comm: in,
	   callback: [ask_console,[day]]
      ].
xattr [name: hour,
       abbrev: hour,
       class: simple,
       type: hour,
       comm: in,
	   callback: [ask_console,[hour]]
      ].
xattr [name: month,
       abbrev: month,
       class: simple,
       type: month,
       comm: in,
	   callback: [ask_console,[month]]
      ].
xattr [name: operation,
       abbrev: oper,
       class: simple,
       type: operation,
       comm: inter
      ].
xattr [name: season,
       abbrev: seaso,
       class: simple,
       type: season,
       comm: inter
      ].
xattr [name: thermostat_settings,
       abbrev: tset,
       class: simple,
       type: thermostat_settings,
       comm: out,
	   callback: [tell_console,[thermostat_settings]]
      ].
xattr [name: today,
       abbrev: today,
       class: simple,
       type: today,
       comm: inter
      ].

%%%%%%%%%%%%%%%%%%%%%%%%% STATES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%% TABLE SCHEMAS DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%

xschm ms/month: [month] ==> [season].
xschm dt: [day] ==> [today].
xschm th: [today,hour] ==> [operation].
xschm os: [operation,season] ==> [thermostat_settings].

%%%%%%%%%%%%%%%%%%%%%%%%%%%% RULES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%

xrule ms/1:
      [month in [1,2,12]]
    ==>
      [season set winter]
    :os/5.
xrule ms/2:
      [month in [3,4,5]]
    ==>
      [season set spring]
    :os/3.
xrule ms/3:
      [month in [6,7,8]]
    ==>
      [season set summer]
    :os/1.
xrule ms/4:
      [month in [9,10,11]]
    ==>
      [season set fall]
    :os/7.

xrule dt/1:
      [day in [mon to fri]]
    ==>
      [today set workday]
    :th/1.
xrule dt/2:
      [day in [sat,sun]]
    ==>
      [today set weekend]
    :th/1.

xrule th/1:
      [today eq workday,
       hour gt 17]
    ==>
      [operation set nbizhrs]
    :os/1.
xrule th/2:
      [today eq weekend,
       hour eq 'any']
    ==>
      [operation set nbizhrs]
    :os/1.
xrule th/3:
      [today eq workday,
       hour lt 9]
    ==>
      [operation set nbizhrs]
    :os/1.
xrule th/4:
      [today eq workday,
       hour in [9 to 17]]
    ==>
      [operation set bizhrs]
    :os/1.

xrule os/1:
      [operation eq nbizhrs,
       season eq summer]
    ==>
      [thermostat_settings set 27].
xrule os/2:
      [operation eq bizhrs,
       season eq summer]
    ==>
      [thermostat_settings set 24].
xrule os/3:
      [operation eq nbizhrs,
       season eq spring]
    ==>
      [thermostat_settings set 15].
xrule os/4:
      [operation eq bizhrs,
       season eq spring]
    ==>
      [thermostat_settings set 20].
xrule os/5:
      [operation eq bizhrs,
       season eq winter]
    ==>
      [thermostat_settings set 18].
xrule os/6:
      [operation eq nbizhrs,
       season eq winter]
    ==>
      [thermostat_settings set 14].
xrule os/7:
      [operation eq nbizhrs,
       season eq fall]
    ==>
      [thermostat_settings set 16].
xrule os/8:
      [operation eq bizhrs,
       season eq fall]
    ==>
      [thermostat_settings set 20].

xcall ask_console : [AttName] >>> (write('Type value for attribute:  '),
								 write(AttName),nl,
								 read(Answer),
								 alsv_new_val(AttName,Answer)).
xcall tell_console : [AttName] >>> (write('Attribute '),write(AttName),write(' output value is '),
								 xstat(current:[AttName,V]),
								 write(V),nl).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File generated by HeKatE Qt Editor ver. M6_5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xstat init1: [day, mon].
xstat init1: [hour, 12].
xstat init1: [month, 4].
xstat eval1: [day, mon].
xstat eval1: [hour, 12].
xstat eval1: [month, 4].
xstat eval1: [season, spring].
xstat eval1: [operation, bizhrs].
xstat eval1: [today,workday].
xstat eval1: [thermostat_settings, 20].

xstat init2: [day, 1].
xstat init2: [hour, 12].
xstat init2: [month, 4].
xstat eval2: [day, 1].
xstat eval2: [hour, 12].
xstat eval2: [month, 4].
xstat eval2: [season, spring].
xstat eval2: [operation, bizhrs].
xstat eval2: [today,workday].
xstat eval2: [thermostat_settings, 20].


xstat init3: [day, sun].
xstat init3: [hour, 19].
xstat init3: [month, 1].
xstat eval3: [day, sun].
xstat eval3: [hour, 19].
xstat eval3: [month, 1].
xstat eval3: [season, winter].
xstat eval3: [operation, nbizhrs].
xstat eval3: [today,weekend].
xstat eval3: [thermostat_settings, 14].

xstat init4: [day, wed].
xstat init4: [hour, 3].
xstat init4: [month, 7].
xstat eval4: [day, wed].
xstat eval4: [hour, 3].
xstat eval4: [month, 7].
xstat eval4: [season, summer].
xstat eval4: [operation, nbizhrs].
xstat eval4: [today,workday].
xstat eval4: [thermostat_settings, 27].

:-retractall(flag_debug(_)).
:-dynamic(wrong/1).
wrong(no).
flag_debug(0).

test([],[]) :- write('Done'),nl,!.

test([I|Inputs],[O|Outputs]) :-
	write('GDI'),nl,
	gox(I,[os],gdi),
	state_get(current,Produced1),
	state_get(O,Expected),
	subset(Produced1,Expected),
	subset(Expected,Produced1),

	write('TDI'),nl,
	gox(I,[os],tdi),
	state_get(current,Produced2),
	subset(Produced2,Expected),
	subset(Expected,Produced2),

	write('DDI'),nl,
	gox(I,[ms,dt,th,os],ddi),
	state_get(current,Produced3),
	subset(Produced3,Expected),
	subset(Expected,Produced3),
	
	test(Inputs,Outputs).

test([I|Inputs],[O|Outputs]) :-
	write('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'),nl,
	write('ERROR: Produced state is different that expected, for states '),
	write(I),
	write(' and '),
	write(O),nl,
	write('ERROR: Produced: '),state_get(current,C),write(C),nl,
	write('ERROR: Expected: '),state_get(O,Expected),write(Expected),nl,
	write('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'),nl,!,
	retractall(wrong(_)),assert(wrong(yes)),
	test(Inputs,Outputs).



:- tell('log.txt'),write('THERMOSTAT'),test([init1,init2,init3,init4],[eval1,eval2,eval3,eval4]), told, (wrong(no),halt(0));(wrong(yes),halt(1)).

